# -*- coding: iso-8859-15 -*-
# MIPS function identifier for IDA
# by Raphal Rigo / France Telecom R&D
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""
Documentation :
	this plugin searches for function prologues and define functions
	in the whole segment
"""


from idaapi import *

cur_i = SegStart(ScreenEA())
end_ea = SegEnd(ScreenEA())
while cur_i <= end_ea:
  print hex(cur_i)
  cur_i = find_binary(cur_i, end_ea, "3C1C??279C??0399E021", 16, SEARCH_DOWN);
  MakeFunction(cur_i, BADADDR)
  cur_i = cur_i + 12
